/*
 * File:   main.c
 * Author: Eduardo
 *
 * Created on 5 de junio de 2017, 17:16
 */

////////////////////////////////////////////////////////////////////////////////
//                              JUEGO DE LED                                  //
//  S1 Modifica el modo                                                       //
//  S2 Modifica la frecuencia                                                 //
////////////////////////////////////////////////////////////////////////////////

#include <pic18.h>
#include "config.h"
#include "typedefs.h"
#include "led.h"
#include "button.h"

#define	_XTAL_FREQ	48000000		//Se define la frecuencia FOSC -- Hay que tener en cuenta los preescalers usados

void setup();
void delay_ms(uint16_t);
void botonPulsado();
void barridoIzq();
void barridoDer();
void barridoBid();

uint8_t a = 0;
uint8_t b = 1;
uint8_t modo = 0;   //Variable que almacena el modo seleccionado
uint8_t freq = 1;   //Variable que almacena la frecuencia seleccionada


void main(void) 
{
    setup();
    
    while (true)
    {
        if (modo == 0)  //Barrido a izquierda
            barridoIzq();
        else if (modo == 1)
            barridoDer();
        else if (modo == 2)
            barridoBid();
    }
}



void setup()
{
   for (a=0; a<8; a++)
        {
            LED_Enable(LED_D1 + a);         //Habilitamos los led. Configura como salida los pines
            LED_Off(LED_D1 + a);            //Empezamos con todos los led apagados
        }
    
    BUTTON_Enable(BUTTON_S1);   //Habilitamos los pulsadores. Configura como entrada los pines
    BUTTON_Enable(BUTTON_S2);   //Habilitamos los pulsadores. Configura como entrada los pines 
}

void botonPulsado()
{
    if (BUTTON_IsPressed(BUTTON_S1))
            modo ++;
    if (BUTTON_IsPressed(BUTTON_S2))
            freq ++;
    
    if (modo > 2)
            modo = 0;
    if (freq > 4)
            freq = 1;
    
    while (BUTTON_IsPressed(BUTTON_S1) || BUTTON_IsPressed(BUTTON_S2)); //Espera hasta soltar boton
}

void barridoIzq()
{
    for (a=8; a>0; a--)
    {
    LED_On(LED_D1 + a);
    delay_ms(100 * freq );
    LED_Off(LED_D1 + a);
    }
}

void barridoDer()
{
    for (a=0; a<8; a++)
    {
    LED_On(LED_D1 + a);
    delay_ms(100 * freq);
    LED_Off(LED_D1 + a);
    }
}

void barridoBid()
{
    if (a > 6)
        b = -1;
    if (a < 1)
        b = 1;
        
    LED_On(LED_D1 + a);
    delay_ms(100 * freq);
    LED_Off(LED_D1 + a);
    a=a+b;
}

void delay_ms(uint16_t i)
{
    if (BUTTON_IsPressed(BUTTON_S1) || BUTTON_IsPressed(BUTTON_S2))
            botonPulsado();
    
    for ( uint16_t x=0; x<i; x++ ) 
    { 
    __delay_ms(1); 
    }
}
